//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "CCmdFrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "DdeClientConvFix"
#pragma resource "*.dfm"
TfrmCCmdr *frmCCmdr;
//---------------------------------------------------------------------------
//This code demonstrates how to connect to Creatures/Creatures 2 using
//Borland C++ builder 3.  Written by Ernest Julyan (ejulyan@mtco.com)
//
//This sample requires the public domain component DdeClientConvFix. BCB 3
//has a bug in the DdeClientConv component that renders it unusable for
//this purpose.
//
//Use code from this sample as you wish.
//---------------------------------------------------------------------------
__fastcall TfrmCCmdr::TfrmCCmdr(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TfrmCCmdr::FormCreate(TObject *Sender)
{
	//center form

	frmCCmdr->Top = (Screen->Height - frmCCmdr->Height) / 2;
	frmCCmdr->Left = (Screen->Width - frmCCmdr->Width) / 2;

    pnlStatus->SimpleText="Attempting to Connect...";

}
//---------------------------------------------------------------------------

void __fastcall TfrmCCmdr::FormShow(TObject *Sender)
{
	//enable connection timer
   	tmrConnection->Enabled = true;

}
//---------------------------------------------------------------------------

void __fastcall TfrmCCmdr::tmrConnectionTimer(TObject *Sender)
{
	//Connection Timer

    //keep trying every second until connected, then
    //enable send, change interval to 10 seconds
	if(DdeClientConv1->SetLink("Vivarium","Whatever"))
    {
        pnlStatus->SimpleText = "Connected to Creatures";
		cmdSend->Enabled = true;
        tmrConnection->Interval = 10000;
        DdeClientConv1->CloseLink();
	}
    else
    {
        pnlStatus->SimpleText = "Not Connected";
		cmdSend->Enabled = false;
   	}
}

//---------------------------------------------------------------------------

void __fastcall TfrmCCmdr::cmdSendClick(TObject *Sender)
{

	//Disable connection timer and Send button to avoid overlapping DDE operations
	tmrConnection->Enabled = false;
    cmdSend->Enabled = false;

	//Establish connection, send data, get result
	if(DdeClientConv1->SetLink("Vivarium","Whatever"))
    {
		if (DdeClientConv1->PokeData("Macro",txtCmd->Text.c_str()))
        {
	    	char *s = DdeClientConv1->RequestData("Macro");
	        txtResult->Text = s;
            //must explicitly delete[] s
			delete[] s;
			//only re-enable Send button here
			cmdSend->Enabled = true;
		}
        else
        {
	        pnlStatus->SimpleText = "Not Connected";
	    }
	}
    else
    {
        pnlStatus->SimpleText = "Not Connected";
    }

    //enable connection timer
	tmrConnection->Enabled = true;
}
//---------------------------------------------------------------------------


